#include "Play.hpp"
#include "defines.hpp"
#include <Graphics/Graphics.hpp>

Play::Play() {
  int i,j;
  for(i=0;i<20;i++)
    for(j=0;j<20;j++)
      color[i][j] = GRAY;

  complete = 0;
  score = 0;
  comp_used = 0;
  user_used = 0;
  comp_num = 20;
  select_num = 5;
  srand(time(0)); 
  kills = 0;
  turns = 0;
  p_x = -1;
  p_y = -1;
}

Play::~Play() {
}

void Play::draw() {
  glClearColor(0.5f, 0.5f, 0.5f, 0.0f);
  glClear(GL_COLOR_BUFFER_BIT);
  //Draw things here.
  update_grid();
  draw_grid();
}

void Play::update_grid()
{
  int mx,my,x,y;
  SDL_GetMouseState(&mx,&my);
  if((mx > 100) && (mx < 700)) 
  {
    //Find what box our mouse is in.
    x = (mx - 100)/30;
    y = 19 - my/30;

    //we can only highlight a blue or gray box.
    if((color[x][y] != GRAY) && (color[x][y] != BLUE))
      return;

    //Replace old color.    
    if((x != p_x) || (y != p_y))
    { 
      color[p_x][p_y] = undercolor;
      undercolor = color[x][y];  
      //Set previous x and y
      p_x = x;
      p_y = y;
    }

    //Finally we can set the new color.
    color[x][y] = LIGHTBLUE;
  }
  else
  {
    color[p_x][p_y] = undercolor;
    p_x = -1;
    p_y = -1;
  }
}

void Play::attack()
{
  int i,mmx,mmy,mx,my,x,y;


  for(i=0;i<comp_num;i++)
  {
begin:
    x = rand() % 20;
    y = rand() % 20;

    switch(color[x][y])
    {
      printf("COLOR: %d\n", color[x][y]);
      case GRAY:
      {
        color[x][y] = BLACK;
        break;
      }
      case BLUE:
      {
        color[x][y] = RED;
        select_num--;
        break;
      }
      default:
      goto begin;
      break;
    }
  }
  user_used = 0;
  comp_used = 0;

  for(x=0;x<20;x++)
    for(y=0;y<20;y++)
    {
      if((color[x][y] == BLUE))
      {
        color[x][y] = GREEN;
        score++;
      }
      SDL_GetMouseState(&mx,&my);
      if((mx > 100) && (mx < 700)) 
      {
        //Find what box our mouse is in.
        mmx = (mx - 100)/30;
        mmy = 19 - my/30;
        if((mmx == x) && (mmy == y))
        {
          if(undercolor == BLUE)
          {
            color[x][y] = GREEN;
            undercolor = GREEN;
          }
        }
      }
    }
  turns++;

  if(turns == 15)
  {
    complete = 1;
    printf("YOU SURVIVED!! SCORE WAS %d.\n PRESS q TO QUIT\n",score);
  }
}


void Play::draw_grid()
{
  float i,j;
  int x,y,count;

  glClearColor(1.0f, 1.0f, 1.0f, 0.0f);
  glClear(GL_COLOR_BUFFER_BIT);

  //Draw the quads
  glBegin(GL_QUADS);
  x=0;
  for(i= -1.0 ; i <= 1.0 ; i+=0.1)
  {
    y=0;
    for(j = -1.0 ; j <= 1.0 ; j+=0.1)
    {
      switch(color[x][y])
      {
        case GRAY:
          {
            glColor4f(0.5f, 0.5f, 0.5f,1.0f);
            break;
          }
        case LIGHTBLUE:
          {
            glColor4f(0.0f, 0.0f, 0.8f,0.5f);
            break;
          }
        case BLACK:
          {
            glColor4f(1.0f, 1.0f, 1.0f,1.0f);
            break;
          }
        case BLUE:
          {
            glColor4f(0.0f, 0.0f, 1.0f,1.0f);
            break;
          }
        case RED:
          {
            glColor4f(1.0f, 0.0f, 0.0f,1.0f);
            break;
          }
        case GREEN:
          {
            glColor4f(0.0f, 1.0f, 0.0f,1.0f);
            break;
          }
        default:
          break;
      }
      y++;
      glVertex2f(i,j);
      glVertex2f(i+0.1,j);
      glVertex2f(i+0.1,j+0.1);
      glVertex2f(i,j+0.1);
    }
    x++;
  }
  glEnd();

  //Draw the grid
  glBegin(GL_LINES);
  glColor4f(1.0f, 1.0f, 1.0f,1.0f);// - (y / float(15.0f)));
  for(i = -1.0; i <= 1.0; i+= 0.1)
  {
    glVertex2f(i,1.0);
    glVertex2f(i,-1.0);
    glVertex2f(1.0,i);
    glVertex2f(-1.0,i);
  }
  glEnd();

  glBegin(GL_QUADS);
  for(count = 0; count < (select_num - user_used); count++)
  {
    glColor4f(0.0f, 0.0f, 1.0f,1.0f);
    glVertex2f(-1.2,0.1 * (2*count + 1)); 
    glVertex2f(-1.1,0.1 * (2*count + 1)); 
    glVertex2f(-1.1,0.1 * (2*count + 2)); 
    glVertex2f(-1.2,0.1 * (2*count + 2)); 
  }


  glEnd();

}


void Play::update(float elapsed_time) {
  //Update game state here.
}

void Play::handle_event(SDL_Event const &event) {
  int mx,my,x,y;


  //Handle events here:
  if (event.type == SDL_KEYDOWN) {
    if (event.key.keysym.sym == SDLK_ESCAPE) {
      //escape quits.
      quit_screen(this);
    }

  if(complete)  
      return;
    
    if(event.key.keysym.sym == SDLK_RETURN)
    {
      if(user_used == select_num)
      {
        attack(); 
        if(select_num == 0)
        {
          printf("YOU LOST!! SCORE WAS %d.\n PRESS q TO QUIT\n",score);
          complete = 1;
        }

      }
    }
  }
  if(complete)  
      return;

  if (event.type == SDL_MOUSEBUTTONDOWN) {
    if(user_used != select_num)
    {
      SDL_GetMouseState(&mx,&my);
      x = (mx - 100)/30;
      y = 19 - my/30;
      switch(undercolor)
      {
        case GRAY:
          {
            color[x][y] = BLUE;
            undercolor = BLUE;
            user_used++;
            break;
          }
        case BLUE:
          {
            user_used--;
            undercolor = GRAY; 
            color[x][y] = GRAY;
            break;
          }
        default:
          {
            break;
          }

          update_grid();
      }
    }
  }
}
